#version 150

precision highp float;
precision highp int;

#define AO_RENDER_NORMAL 	1
#define AO_RENDER_FRONTPOS 	2
#define AO_RENDER_BACKPOS 	3
#define ALPHA_THRES             0.009   /*above which the pixel is rendered*/
// final color output
out vec4 FragColor;

// input var from vertex shader
in vec3 NormalToFrag;
in vec4 ColorToFrag;
in vec2 TexCoordToFrag;

struct MaterialSt {
	int 	Has_Texture;
    int     Do_Sphere_Map;
    int     Has_Vertex_Color;
	int 	Is_Transparent;
    float   Transparency;
} ;

uniform MaterialSt Material;

// control
struct AOControlSt {
	int RenderType;
} ;

uniform AOControlSt AOControl;

// Texture samplers
uniform sampler2D 		ColorTexture;

void main()
{
    bool cast_ao=true;
    
    if (cast_ao)
    {
        if (Material.Has_Texture>0)
        {
            vec4 tex_Color = texture(ColorTexture, TexCoordToFrag);
            cast_ao=((Material.Is_Transparent>0?Material.Transparency:1.0) * (Material.Do_Sphere_Map>0?1.0:tex_Color.a))>ALPHA_THRES;
        }
        else if (Material.Has_Vertex_Color>0)
        {
            cast_ao=((Material.Is_Transparent>0?Material.Transparency:1.0) * ColorToFrag.a)>ALPHA_THRES;
        }
        else
            cast_ao=(Material.Is_Transparent>0?Material.Transparency:1.0)>ALPHA_THRES;
    }
    
    if (cast_ao)
{	
	vec3 normal = normalize(NormalToFrag);
	// TODO bump
	if (AOControl.RenderType==AO_RENDER_NORMAL)
	{
		FragColor = vec4(normal, 1.0);
	}
	else
	{
		FragColor = vec4(0, 0, 0, 1.0);		/*no use; front/back pos is written to depth buffer*/
	}
    }
    else
        discard;
        
}
