#version 150

precision highp float;
precision highp int;

#define AO_RENDER_NORMAL 	1
#define AO_RENDER_FRONTPOS 	2
#define AO_RENDER_BACKPOS 	3
// vertex attributes
in vec3 MCVertex;
in vec3 MCNormal;
in vec2 MCTexCoord;
in vec4 MCColor;

// out var to fragment shader
out vec3 NormalToFrag;
out vec4 PxPos;

// transformation matrices

//uniform mat4 renderPJMatrix;
//uniform mat4 renderVMMatrix;
//uniform mat4 renderMMMatrix;
out vec2 TexCoordToFrag;
out vec4 ColorToFrag;


//MJY 06/23/14
uniform mat4 renderprojmvMatrix;
uniform mat3 renderNMMatrix;
// control
struct AOControlSt {
	int RenderType;
} ;

uniform AOControlSt AOControl;

void main()
{
    ColorToFrag = MCColor;
    TexCoordToFrag = MCTexCoord;
    
	if (AOControl.RenderType==AO_RENDER_NORMAL)
	{
		NormalToFrag = renderNMMatrix * MCNormal;
	}
	
	gl_Position = renderprojmvMatrix * vec4(MCVertex,1);
}
