#version 150

precision highp float;
precision highp int;


out vec4 FragColor;

// input var from vertex shader
in vec2 TexCoordToFrag;
in vec4 ColorToFrag;

struct MaterialSt {
	int 	Has_Texture;
    int     Has_Vertex_Color;
	int 	Is_Transparent;
    float   Transparency;
} ;

uniform MaterialSt Material;

uniform sampler2D ColorTexture;

uniform vec4 basic_color;

void main()
{	
    // use texture
	if (Material.Has_Texture>0)
	{
        vec4 tex_Color = texture(ColorTexture, TexCoordToFrag);
        FragColor = vec4(tex_Color.rgb, (Material.Is_Transparent>0?Material.Transparency:1.0) * tex_Color.a);
	}
    // use vertex color
    else if (Material.Has_Vertex_Color>0)
    {
        FragColor = vec4(ColorToFrag.rgb, (Material.Is_Transparent>0?Material.Transparency:1.0) * ColorToFrag.a);
    }
    else
	{
        FragColor = vec4(basic_color.rgb, (Material.Is_Transparent>0?Material.Transparency:1.0) * basic_color.a);
	}
}
