#version 150

precision highp float;
precision highp int;

out vec4 FragColor;
struct ShadowControlSt{
	int 	MapWidth;
	int 	MapHeight;
	int 	CubeSize;
	int 	CubeFace;
	float 	SmoothQuality;
	float 	Softness;
} ;

uniform ShadowControlSt ShadowControl;

uniform sampler2D ColorTexture;
in vec2 TexCoord;
void main()
{
	float minFilterSize = 0.0;
	float maxFilterSize = 10.0;
	float FilterSize = minFilterSize + ShadowControl.Softness*(maxFilterSize - minFilterSize);
	int filterSizei = int(FilterSize);
	float PixelSizeX = 1.0/float(ShadowControl.MapWidth);
	float PixelSizeY = 1.0/float(ShadowControl.MapHeight);
	float minJumpSize = 1.0;
	float maxJumpSize = max(FilterSize/2.0,1.0);
	int jump = int(minJumpSize + (1.0-ShadowControl.SmoothQuality)*(maxJumpSize-minJumpSize));
	
	vec2 sumc = vec2(0.0,0.0);
	float sumi = 0.0;

	for (int i=-filterSizei;i<=filterSizei;i=i+jump)
	{
		for (int j=-filterSizei;j<=filterSizei;j=j+jump)
		{
			sumc += texture(ColorTexture, TexCoord+vec2(float(i)*PixelSizeX,float(j)*PixelSizeY)).xy;
			sumi+=1.0;
		}
	}
    
    if (sumi>0.0)
        sumc = sumc / sumi;

	FragColor = vec4(sumc,0.0,1.0);
}
