#version 150

precision highp float;
precision highp int;

smooth in vec4 pos;
in vec4 source;       // starting point for dashed line

out vec4 FragColor;

uniform int UseStipple;
uniform int StipplePattern;
uniform int StippleFactor;

uniform vec4 basic_color;

uniform int  RenderArea_Width;
uniform int  RenderArea_Height;


void main()
{
    if (UseStipple == 0)
    {   FragColor = basic_color;
    }
    else
    {
        vec2 diffXY = pos.xy/pos.w - source.xy/source.w;
    
        vec2 screenDiffXY = vec2(diffXY.x*float(RenderArea_Width), diffXY.y*float(RenderArea_Height));
        int offset = int(length(screenDiffXY));
    
        int bit = int(offset/(2*StippleFactor)) & 15;
        if((StipplePattern & (1<<bit)) == 0)
        {
            discard;
        }
        else
        {
            FragColor = basic_color;
        }
    }
    
}
