#version 150

precision highp float;
precision highp int;

// vertex attributes
in vec3 MCVertex;
in vec2 MCTexCoord;
in vec4 MCColor;

// out var to fragment shader
out vec4 PxPos;

// transformation matrices
//uniform mat4 lightPJMatrix;
//uniform mat4 lightVMMatrix;
//uniform mat4 renderMMMatrix;
out vec2 TexCoordToFrag;
out vec4 ColorToFrag;

// light
struct LightSt{
	int 	Type;
	float 	NearClip;
	float 	FarClip;
} ;

uniform LightSt Light;

struct MaterialSt {
	int 	Has_Texture;
    int     Do_Sphere_Map;
    int     Has_Vertex_Color;
	int 	Is_Transparent;
    float   Transparency;
	int		Cast_Shadow;
} ;

uniform MaterialSt Material;

//MJY 06/23/14
uniform mat4 lightPJMatrix;
uniform mat4 lightmvMatrix;

void main()
{
    ColorToFrag = MCColor;
    
    TexCoordToFrag = MCTexCoord;
    
	PxPos = lightmvMatrix * vec4(MCVertex,1);
	
	gl_Position = lightPJMatrix * PxPos;
}
